package de.subway_surfers.vpr_app;

import javafx.collections.ListChangeListener;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.scene.control.*;
import javafx.scene.layout.Background;
import javafx.scene.layout.GridPane;
import javafx.scene.layout.HBox;
import javafx.scene.layout.VBox;

import java.util.Random;

public class AccounterstellungMitarbeiter {

	private @FXML Label status;
	private @FXML Label einmalpw;
	private @FXML HBox kindanzeige;
	private @FXML GridPane kindDaten;
	private @FXML RadioButton typMitarbeiter;
	private @FXML RadioButton typEltern;
	private       ToggleGroup accountTyp;

	public void initialize() {
		accountTyp = new ToggleGroup();
		accountTyp.getToggles().add(typEltern);
		accountTyp.getToggles().add(typMitarbeiter);
		einmalpw.setText(einmalPwGenerieren());
	}

	public void onZurueck(ActionEvent actionEvent) {
		VerwaltungApplication.sceneWechseln("hauptmenue_mitarbeiter-view.fxml");
	}

	public void onAbmelden(ActionEvent actionEvent) {
		VerwaltungApplication.abmelden();
	}

	public void onTypMitarbeiter(ActionEvent actionEvent) {
		kindDaten.getChildren().clear();
	}

	public void onTypEltern(ActionEvent actionEvent) {
		Label ueberschrift = new Label();
		ueberschrift.setText("Daten des Kindes:");
		kindDaten.addRow(0);
		kindDaten.addColumn(0);
		kindDaten.addRow(1);
		kindDaten.add(ueberschrift,0,0);

		kindDaten.addRow(1);
		Label vname = new Label("Vorname:");
		kindDaten.add(vname, 0, 1);
		TextField vnameEingabe = new TextField();
		kindDaten.add(vnameEingabe, 1, 1);

		kindDaten.addRow(2);
		Label nname = new Label("Nachname:");
		kindDaten.add(nname, 0, 2);
		TextField nnameEingabe = new TextField();
		kindDaten.add(nnameEingabe, 1, 2);

		kindDaten.addRow(3);
		Label geburtstag = new Label("Geburtstag: ");
		kindDaten.add(geburtstag, 0, 3);
		DatePicker geburtstagEingabe = new DatePicker();
		geburtstagEingabe.setEditable(false);
		kindDaten.add(geburtstagEingabe, 1, 3);

		kindDaten.addRow(4);
		Button hinzufuegen = new Button("hinzufügen");
		kindDaten.add(hinzufuegen, 1, 4);

		kindDaten.addRow(5);
		hinzufuegen.setOnAction(e -> {
			Button neues = new Button(vnameEingabe.getText());

			boolean vnameGueltig = false;
			boolean gebGueltig = false;
			boolean nnameGueltig = false;

			if (!vnameEingabe.getText().equals("")) {
				vnameGueltig = true;
			}

			if (!nnameEingabe.getText().equals("")) {
				nnameGueltig = true;
			}

			if (!geburtstagEingabe.getEditor().getText().equals("")) {
				gebGueltig = true;
			}

			if (vnameGueltig && gebGueltig && nnameGueltig) {
				kindanzeige.getChildren().add(neues);
				neues.setOnAction(a -> {
					((HBox) neues.getParent()).getChildren().remove(neues);
				});
				vnameEingabe.setText("");
				nnameEingabe.setText("");
				geburtstagEingabe.getEditor().setText("");
			}
		});
	}

	private String einmalPwGenerieren() {
		final int pwLaenge = 8;
		String pw = "";
		Random zufall = new Random();
		for (int i = 0; i < pwLaenge; i++) {
			pw += (char)zufall.nextInt('A', 'Z' + 1);
		}
		return pw;
	}

	private boolean eingabenGueltig() {

		return true;
	}

	public void onSpeichern(ActionEvent actionEvent) {
		if (eingabenGueltig()) {
			status.setText("Daten Erfolgreich gespeichert");
			einmalpw.setText(einmalPwGenerieren());

		}

	}

}
